diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/utils/print-introspected-doxygen.cc ns-3.31/utils/print-introspected-doxygen.cc
--- ns-3.30.1/utils/print-introspected-doxygen.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/utils/print-introspected-doxygen.cc	2020-06-27 17:38:30.000000000 -0700
@@ -1428,7 +1583,7 @@
   NS_LOG_FUNCTION_NOARGS ();
   bool outputText = false;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Usage ("Generate documentation for all ns-3 registered types, "
 	     "trace sources, attributes and global variables.");
   cmd.AddValue ("output-text", "format output as plain text", outputText);
@@ -1447,8 +1602,6 @@
       std::cout << "/* -*- Mode:C++; c-file-style:\"gnu\"; "
 	           "indent-tabs-mode:nil; -*- */\n"
 		<< std::endl;
-      std::cout << "#include \"ns3/log.h\""
-                << std::endl;
     }
 
   // Doxygen file header
@@ -1462,58 +1615,10 @@
             << "Edit that file instead.\n"
             << commentStop
             << std::endl;
-  
-  // Get typical aggregation relationships.
-  StaticInformation info = GetTypicalAggregations ();
-  
-  NameMap nameMap = GetNameMap (info);
-
-  // Iterate over the map, which will print the class names in
-  // alphabetical order.
-  for (NameMapIterator nameMapIterator = nameMap.begin ();
-       nameMapIterator != nameMap.end ();
-       nameMapIterator++)
-    {
-      // Get the class's index out of the map;
-      std::string name = nameMapIterator->first;
-      int32_t i = nameMapIterator->second;
-      TypeId tid;
-
-      if (i >= 0)
-        {
-          tid = TypeId::GetRegistered (i);
-          if (tid.MustHideFromDocumentation ())
-            {
-              continue;
-            }
-          name = tid.GetName ();
-        }
-      
-      std::cout << commentStart << std::endl;
-      
-      std::cout << classStart << name << std::endl;
-      std::cout << std::endl;
-
-      if (i >= 0)
-        {
-          PrintConfigPaths (std::cout, info, tid);
-          PrintAttributes (std::cout, tid);
-          PrintTraceSources (std::cout, tid);
-          PrintSize (std::cout, tid);
-        }
-      else
-        {
-          std::cout << "Introspection could not find Config paths for " << name
-                    << " in this build because the parent module"
-                    << " was not included in the waf configuration."
-                    << breakBoth
-                    << std::endl;
-        }
-      
-      std::cout << commentStop << std::endl;
-    }  // class documentation
-
 
+  PrintTypeIdBlocks (std::cout);
+  
+  PrintAllTypeIds (std::cout);
   PrintAllAttributes (std::cout);
   PrintAllGlobals (std::cout);
   PrintAllLogComponents (std::cout);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/VERSION ns-3.31/VERSION
--- ns-3.30.1/VERSION	2019-09-18 11:07:48.000000000 -0700
+++ ns-3.31/VERSION	2020-06-27 17:39:17.000000000 -0700
@@ -1 +1 @@
-3.30.1
+3.31
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/wscript ns-3.31/wscript
--- ns-3.30.1/wscript	2019-08-14 09:24:31.000000000 -0700
+++ ns-3.31/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -11,6 +11,8 @@
 import shlex
 import subprocess
 import textwrap
+import fileinput
+import glob
 
 from utils import read_config_file
 
@@ -108,20 +110,12 @@
 
 # Print the sorted list of module names in columns.
 def print_module_names(names):
-    # Sort the list of module names.
-    names.sort()
-
-    # Print the list of module names in 3 columns.
-    i = 1
-    for name in names:
-        print(name.ljust(25), end=' ')
-        if i == 3:
-                print()
-                i = 0
-        i = i+1
-
-    if i != 1:
-        print()
+    """Print the list of module names in 3 columns."""
+    for i, name in enumerate(sorted(names)):
+        if i % 3 == 2 or i == len(names) - 1:
+          print(name)
+        else:
+          print(name.ljust(25), end=' ')
 
 # return types of some APIs differ in Python 2/3 (type string vs class bytes)
 # This method will decode('utf-8') a byte object in Python 3, 
@@ -170,10 +164,16 @@
 
     opt.add_option('--lcov-report',
                    help=('Generate a code coverage report '
-                         '(use this option at build time, not in configure)'),
+                         '(use this option after configuring with --enable-gcov and running a program)'),
                    action="store_true", default=False,
                    dest='lcov_report')
 
+    opt.add_option('--lcov-zerocounters',
+                   help=('Zero the lcov counters'
+                         '(use this option before rerunning a program, when generating repeated lcov reports)'),
+                   action="store_true", default=False,
+                   dest='lcov_zerocounters')
+
     opt.add_option('--run',
                    help=('Run a locally built program; argument can be a program name,'
                          ' or a command starting with the program name.'),
@@ -200,6 +200,10 @@
                          ' argument is the path to the python program, optionally followed'
                          ' by command-line options that are passed to the program.'),
                    type="string", default='', dest='pyrun_no_build')
+    opt.add_option('--gdb',
+                   help=('Change the default command template to run programs and unit tests with gdb'),
+                   action="store_true", default=False,
+                   dest='gdb')
     opt.add_option('--valgrind',
                    help=('Change the default command template to run programs and unit tests with valgrind'),
                    action="store_true", default=False,
@@ -244,6 +248,10 @@
                          'but do not wait for ns-3 to finish the full build.'),
                    action="store_true", default=False,
                    dest='doxygen_no_build')
+    opt.add_option('--docset',
+                   help=('Create Docset, without building. This requires the docsetutil tool from Xcode 9.2 or earlier. See Bugzilla 2196 for more details.'),
+                   action="store_true", default=False,
+                   dest="docset_build")
     opt.add_option('--enable-des-metrics',
                    help=('Log all events in a json file with the name of the executable (which must call CommandLine::Parse(argc, argv)'),
                    action="store_true", default=False,
@@ -547,8 +555,6 @@
         elif not_built_name in conf.env['NS3_ENABLED_CONTRIBUTED_MODULES']:
             conf.env['NS3_ENABLED_CONTRIBUTED_MODULES'].remove(not_built_name)
 
-    conf.recurse('src/mpi')
-
     # for suid bits
     try:
         conf.find_program('sudo', var='SUDO')
@@ -767,6 +773,9 @@
 def add_examples_programs(bld):
     env = bld.env
     if env['ENABLE_EXAMPLES']:
+        # Add a define, so this is testable from code
+        env.append_value('DEFINES', 'NS3_ENABLE_EXAMPLES')
+
         try:
             for dir in os.listdir('examples'):
                 if dir.startswith('.') or dir == 'CVS':
@@ -1003,6 +1012,14 @@
                 if obj.module not in bld.env.NS3_ENABLED_MODULES and obj.module not in bld.env.NS3_ENABLED_CONTRIBUTED_MODULES:
                     bld.exclude_taskgen(obj)
 
+            # disable python bindings for disabled modules
+            if 'pybindgen' in obj.name:
+                if ("ns3-%s" % obj.module) not in modules and ("ns3-%s" % obj.module) not in contribModules:
+                    bld.exclude_taskgen(obj)
+            if 'pyext' in getattr(obj, "features", []):
+                if ("ns3-%s" % obj.module) not in modules and ("ns3-%s" % obj.module) not in contribModules:
+                    bld.exclude_taskgen(obj)
+
 
     if env['NS3_ENABLED_MODULES']:
         env['NS3_ENABLED_MODULES'] = list(modules)
@@ -1056,7 +1073,7 @@
         bld.env['PRINT_BUILT_MODULES_AT_END'] = False 
 
     if Options.options.doxygen_no_build:
-        _doxygen(bld)
+        _doxygen(bld, skip_pid=True)
         raise SystemExit(0)
 
     if Options.options.run_no_build:
@@ -1083,7 +1100,6 @@
     _cleandir('doc/manual/build')
     _cleandir('doc/manual/source-temp')
     _cleandir('doc/tutorial/build')
-    _cleandir('doc/tutorial-pt-br/build')
     _cleandir('doc/models/build')
     _cleandir('doc/models/source-temp')
 
@@ -1141,6 +1157,9 @@
     if Options.options.lcov_report:
         lcov_report(bld)
 
+    if Options.options.lcov_zerocounters:
+        lcov_zerocounters(bld)
+
     if Options.options.run:
         wutils.run_program(Options.options.run, env, wutils.get_command_template(env),
                            visualize=Options.options.visualize)
@@ -1223,15 +1242,9 @@
         wutils.run_argv([shell], env, os_env)
 
 
-def _doxygen(bld):
+def _print_introspected_doxygen(bld):
     env = wutils.bld.env
     proc_env = wutils.get_proc_env()
-
-    if not env['DOXYGEN']:
-        Logs.error("waf configure did not detect doxygen in the system -> cannot build api docs.")
-        raise SystemExit(1)
-        return
-
     try:
         program_obj = wutils.find_program('print-introspected-doxygen', env)
     except ValueError: 
@@ -1247,6 +1260,8 @@
                    "generating doxygen docs...")
         raise SystemExit(1)
 
+    Logs.info("Running print-introspected-doxygen")
+
     # Create a header file with the introspected information.
     doxygen_out = open(os.path.join('doc', 'introspected-doxygen.h'), 'w')
     if subprocess.Popen([prog], stdout=doxygen_out, env=proc_env).wait():
@@ -1259,12 +1274,115 @@
         raise SystemExit(1)
     text_out.close()
 
+    # Gather the CommandLine doxy
+    # test.py appears not to create or keep the output directory
+    # if no real tests are run, so we just stuff all the
+    # .command-line output files into testpy-output/
+    # NS_COMMANDLINE_INTROSPECTION=".." test.py --nowaf --constrain=example
+    Logs.info("Running CommandLine introspection")
+    proc_env['NS_COMMANDLINE_INTROSPECTION'] = '..'
+    subprocess.run(["./test.py", "--nowaf", "--constrain=example"],
+                   env=proc_env, stdout=subprocess.DEVNULL)
+    
+    doxygen_out = os.path.join('doc', 'introspected-command-line.h')
+    try:
+        os.remove(doxygen_out)
+    except OSError as e:
+        pass
+
+    with open(doxygen_out, 'w') as out_file:
+        lines="""
+/* This file is automatically generated by
+CommandLine::PrintDoxygenUsage() from the CommandLine configuration
+in various example programs.  Do not edit this file!  Edit the
+CommandLine configuration in those files instead.
+*/\n
+"""
+        out_file.write(lines)
+    out_file.close()
+
+    with open(doxygen_out,'a') as outfile:
+        for in_file in glob.glob('testpy-output/*.command-line'):
+            with open(in_file,'r') as infile:
+                outfile.write(infile.read())
+                
+def _doxygen(bld, skip_pid=False):
+    env = wutils.bld.env
+    proc_env = wutils.get_proc_env()
+
+    if not env['DOXYGEN']:
+        Logs.error("waf configure did not detect doxygen in the system -> cannot build api docs.")
+        raise SystemExit(1)
+        return
+
+    if not skip_pid:
+        _print_introspected_doxygen(bld)
+
     _getVersion()
     doxygen_config = os.path.join('doc', 'doxygen.conf')
     if subprocess.Popen(env['DOXYGEN'] + [doxygen_config]).wait():
         Logs.error("Doxygen build returned an error.")
         raise SystemExit(1)
 
+def _docset(bld):
+    # Get the doxygen config
+    doxyfile = os.path.join('doc', 'doxygen.conf')
+    Logs.info("docset: reading " + doxyfile)
+    doxygen_config = open(doxyfile, 'r')
+    doxygen_config_contents = doxygen_config.read()
+    doxygen_config.close()
+
+    # Create the output directory
+    docset_path = os.path.join('doc', 'docset')
+    Logs.info("docset: checking for output directory " + docset_path)
+    if not os.path.exists(docset_path):
+        Logs.info("docset: creating output directory " + docset_path)
+        os.mkdir(docset_path)
+
+    doxyfile = os.path.join('doc', 'doxygen.docset.conf')
+    doxygen_config = open(doxyfile, 'w')
+    Logs.info("docset: writing doxygen conf " + doxyfile)
+    doxygen_config.write(doxygen_config_contents)
+    doxygen_config.write(
+        """
+        HAVE_DOT = NO
+        GENERATE_DOCSET = YES
+        DISABLE_INDEX = YES
+        SEARCHENGINE = NO
+        GENERATE_TREEVIEW = NO
+        OUTPUT_DIRECTORY=""" + docset_path + "\n"
+        )
+    doxygen_config.close()
+
+    # Run Doxygen manually, so as to avoid build
+    Logs.info("docset: running doxygen")
+    env = wutils.bld.env
+    _getVersion()
+    if subprocess.Popen(env['DOXYGEN'] + [doxyfile]).wait():
+        Logs.error("Doxygen docset build returned an error.")
+        raise SystemExit(1)
+
+    # Build docset
+    docset_path = os.path.join(docset_path, 'html')
+    Logs.info("docset: Running docset Make")
+    if subprocess.Popen(["make"], cwd=docset_path).wait():
+        Logs.error("Docset make returned and error.")
+        raise SystemExit(1)
+
+    # Additional steps from
+    #   https://github.com/Kapeli/Dash-User-Contributions/tree/master/docsets/ns-3
+    docset_out = os.path.join(docset_path, 'org.nsnam.ns3.docset')
+    icons = os.path.join('doc', 'ns3_html_theme', 'static')
+    shutil.copy(os.path.join(icons, 'ns-3-bars-16x16.png'),
+                os.path.join(docset_out, 'icon.png'))
+    shutil.copy(os.path.join(icons, 'ns-3-bars-32x32.png'),
+                os.path.join(docset_out, 'icon@x2.png'))
+    shutil.copy(os.path.join(docset_path, 'Info.plist'),
+                os.path.join(docset_out, 'Contents'))
+    shutil.move(docset_out, os.path.join('doc', 'ns-3.docset'))
+
+    print("Docset built successfully.")
+    
 
 def _getVersion():
     """update the ns3_version.js file, when building documentation"""
@@ -1301,7 +1419,7 @@
 
     def execute(self):
         _getVersion()
-        for sphinxdir in ["manual", "models", "tutorial", "tutorial-pt-br"] :
+        for sphinxdir in ["manual", "models", "tutorial"] :
             self.sphinx_build(os.path.join("doc", sphinxdir))
      
 
@@ -1321,7 +1439,20 @@
     if not env['GCOV_ENABLED']:
         raise WafError("project not configured for code coverage;"
                        " reconfigure with --enable-gcov")
-
+    try:
+        subprocess.call(["lcov", "--help"], stdout=subprocess.DEVNULL)
+    except OSError as e:
+        if e.errno == os.errno.ENOENT:
+            raise WafError("Error: lcov program not found")
+        else:
+            raise
+    try:
+        subprocess.call(["genhtml", "--help"], stdout=subprocess.DEVNULL)
+    except OSError as e:
+        if e.errno == os.errno.ENOENT:
+            raise WafError("Error: genhtml program not found")
+        else:
+            raise
     os.chdir(out)
     try:
         lcov_report_dir = 'lcov-report'
@@ -1332,15 +1463,34 @@
             raise SystemExit(1)
 
         info_file = os.path.join(lcov_report_dir, 'report.info')
-        lcov_command = "../utils/lcov/lcov -c -d . -o " + info_file
+        lcov_command = "lcov -c -d . -o " + info_file
         lcov_command += " -b " + os.getcwd()
         if subprocess.Popen(lcov_command, shell=True).wait():
             raise SystemExit(1)
 
-        genhtml_command = "../utils/lcov/genhtml -o " + lcov_report_dir
+        genhtml_command = "genhtml -o " + lcov_report_dir
         genhtml_command += " " + info_file
         if subprocess.Popen(genhtml_command, shell=True).wait():
             raise SystemExit(1)
     finally:
         os.chdir("..")
 
+def lcov_zerocounters(bld):
+    env = bld.env
+
+    if not env['GCOV_ENABLED']:
+        raise WafError("project not configured for code coverage;"
+                       " reconfigure with --enable-gcov")
+    try:
+        subprocess.call(["lcov", "--help"], stdout=subprocess.DEVNULL)
+    except OSError as e:
+        if e.errno == os.errno.ENOENT:
+            raise WafError("Error: lcov program not found")
+        else:
+            raise
+
+    os.chdir(out)
+    lcov_clear_command = "lcov -d . --zerocounters"
+    if subprocess.Popen(lcov_clear_command, shell=True).wait():
+        raise SystemExit(1)
+    os.chdir("..")
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/wutils.py ns-3.31/wutils.py
--- ns-3.30.1/wutils.py	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/wutils.py	2020-06-27 17:38:30.000000000 -0700
@@ -110,9 +110,20 @@
 
 def run_argv(argv, env, os_env=None, cwd=None, force_no_valgrind=False):
     proc_env = get_proc_env(os_env)
-    if Options.options.valgrind and not force_no_valgrind:
-        if Options.options.command_template:
-            raise WafError("Options --command-template and --valgrind are conflicting")
+
+    if Options.options.valgrind and Options.options.command_template:
+        raise WafError("Options --command-template and --valgrind are conflicting")
+    if Options.options.gdb and Options.options.command_template:
+        raise WafError("Options --command-template and --gdb are conflicting")
+    if Options.options.gdb and Options.options.valgrind:
+        raise WafError("Options --valgrind and --gdb are conflicting")
+
+    if Options.options.gdb:
+        argv = ["gdb", "--args"] + argv
+        proc = subprocess.Popen(argv, env=proc_env, cwd=cwd)
+        retval = proc.wait()
+        return retval
+    elif Options.options.valgrind and not force_no_valgrind:
         if not env['VALGRIND']:
             raise WafError("valgrind is not installed")
         # Use the first program found in the env['VALGRIND'] list
@@ -150,7 +161,7 @@
         if signame:
             raise WafError("Command %s terminated with signal %s."
                                  " Run it under a debugger to get more information "
-                                 "(./waf --run <program> --command-template=\"gdb --args %%s <args>\")." % (argv, signame))
+                                 "(./waf --run <program> --gdb\")." % (argv, signame))
         else:
             raise WafError("Command %s exited with code %i" % (argv, retval))
     return retval
